/*
    FileHelpCmd.cc

    Will Eighteen, 2000, 2006: will@opaline.demon.co.uk
*/

#include "FileHelpCmd.h"
#include "Application.h"
#include <TextEdit.h>


FileHelpCmd::FileHelpCmd ( const char *name, int active ) :  NoUndoCmd ( name, active )
{
	_editRealised = FALSE;
}


FileHelpCmd::~FileHelpCmd()
{
	// empty
}


void FileHelpCmd::doCommand()
{
	if (_editRealised == TRUE )
		return;

	_edit = new TextEdit ( ( char * ) name(), TRUE, &FileHelpCmd::okCallback, &FileHelpCmd::cancelCallback, ( void * ) this );	
	_edit->setRows ( 19 );
	_edit->setColumns ( 70 );
	_editRealised = TRUE;
	_edit->execute();
	_edit->setText ( "Menu button help follows the application button \
layout.\n\n\nFile\n\nNew\nCreates a new wave, template file or mix status \
file. Any new file created is immediately written; there is no 'save'.\
\n\nNew / Wave\nPops up a file requestor. Overwriting of an existing file is \
not allowed: existing files must be deleted manually before new files of \
the same name can be created. A new unique file is created by entering \
the name into the 'Selection' box and activating 'OK'.\n\nNew / Template\n\
Pops up a menu allowing selection of template types: integer, floating point \
and, if you have csound, spatial (for positioning sound in the horizontal \
plane).\nNote that the mixer gain and pan templates must be of type float. \
Note also that although the 'New Template' command allows the saving of files \
with any name and suffix, it is required that integer templates have the \
suffix '.int' and floating-point templates the suffix '.flt'. The 'Load \
Template' command will give an error if these suffixes are missing. \
\n\n\nNew / Template / <Integer\\Float>\nSelection of either \
integer or float templates pops up a submenu allowing the size of the file to \
be determined by\n\na) choosing from a list of \
loaded wave files (if any have been loaded);\nb) selecting a wave file from \
disk (a file requestor pops up);\nc) choosing 'User defined size', \
which allows entry of a numeric value into a popup box.\n\nMethods a and b \
create a template with a number of data points equal to the number of wave \
samples.\n\nNew / Template / Spatial\nPops up a menu showing loaded waves. Selecting a \
wave causes blank templates to be created for that wave in the default \
directory (if none exist for that wave). Parameter view popups allow drawing \
of parameter changes either by mouse right button or by use of the 'Edit / Shape \
template' and 'Edit / Shift/scale' menus. The parameter templates are used to \
produce a transformed stereo output from the mono input wave selected (if you \
have CSound installed).\nNote: the wave file is loaded read-only during \
spatial template creation\\editing. Only the template files can be \
changed.\n\nNew / Mix\nProduces three menus: gain, pan, wave \
selection, and also a mix window showing loaded wave files with associated \
gain and pan to be used during mixdown.\nThe gain and pan menus have no \
referent until a selection is made in the wave selection menu. Gain and pan \
then apply to the selected wave, the results appearing in the mix window. \
Note that default pan and gain values apply - pan central, gain unity.\n\
Floating point templates may be applied to the wave files during mixdown as \
well as fixed (time-invariant) values.\nThe templates allow time-varying \
gain and pan. The data in a template may be created by\n\na) the \
'Edit/Shape template' menu;\nb) drawing in the template view by holding down \
the right mouse button in the window and dragging.\nc) using a file of another \
type (e.g. wave file) and applying the converters in Edit / Convert (in the \
case of using a wave file the operations would be Wave to Int then Int to \
Float, followed by rescaling and shifting as necessary).\n\nSee also \
'Help / Mixer'\n\n\nLoad\nLoads a wave or template file. Note that any \
loaded wave file will be used during mixdown to produce the final output. \
Template files are only used if they have been associated with a wave file \
in 'File / New / Mix'.\n\nLoad / Wave\nPops up a file requestor allowing selection \
a wave file (note: the 'help' button is unimplemented).\n\
Mixwave only recognises .wav files with a default 44-byte header. Some \
programs store addtional information in this header; these must be converted \
by use of a suitable utility such as 'sox': 'sox in.wav out.wav' produces a \
file in the correct format.\nNote.\n\
If the WaveCtrlCmd popup ('Options / Wave control') isn't up, the mix may not \
be what you expect, since it relies on the last toggle settings when the \
popup was active, a wave view was active _and_ the 'region' toggle button \
for that wave was clicked. In short, if you do a 'load wave' or 'state load', \
select a viewed wave region, then do 'File/Mixdown', you won't get \
the region-only mixdown; rather, the entire wave will be used. Selected range \
values aren't transferred to the mixdown unless wave control is active.\n\n\
Load / Template\nPops up a file requestor 'Template load_popup' allowing \
selection of a floating-point template file to be used for gain or pan. A \
further popup appears after the template is loaded, 'Template sync_wave_popup'; \
this allows linking of the template to a particular wave file. Note that this \
only happens if 'Options / System control / Time sync.' is set to 'ON'.\n\
It is not necessary to link a wave to a template; if 'Cancel' is chosen or no \
wave file selected in the sync_wave_popup, then only the template is \
loaded.\n\nUse of time sync. 'ON' and selection of a wave file to be associated \
with a template means that the numeric data displays and mouse actions of \
both files are connected. Use of time sync. ON produces another button in the \
system control menu which allows the wave file to set the template or \
vice-versa. If the 'Wave->template' option is displayed, then selecting a \
region in the wave file highlights the corresponding region in the template \
file. Changes in that template region will correspondingly affect the wave \
file at that time if the template is selected for use as gain or pan \
information during 'New Mix'. This allows dynamic control of pan and gain \
rather than simple static settings.\n\n\n\
View\nAllows graphical display of wave and template files. If the right \
mouse button is depressed and the mouse dragged in the view window, the file \
displayed is edited (unless it is read-only). This is a direct operation on the \
file, the window merely reflecting the changes to the file data. There \
is also no undo, so it is advisable to either use a copy of the file you \
intend to manipulate or to be absolutely sure what you are doing. Once the \
right mouse button is clicked and the mouse moved, the file is changed.\n\n\
Left click and horizontal drag in a window causes a selection to be made; \
this is highlighted. Left click and vertical drag above or below the central \
third of the window changes the scale. Left click and drag outside the window \
causes any corresponding data not already available for display to be loaded.\
\n\nThe right pane of the view window has a selection of buttons. 'Ok' and \
'Cancel' are self-explanatory. 'Ok' causes current settings (including edit \
regions) to be saved; 'Cancel' discards them. It should be noted that if a \
selection is present in a wave file, then only that selection will be added \
to the output during mixdown.\n\n\
For further information on the view window, see Help/Viewer.\n\n\
View / <Wave\\Template>\nPops up a menu of loaded wave or template files. \
Selection from this menu causes a wave viewer to appear with a default \
section of the relevant file loaded (determined by Options / Mix / Mix buffer \
size).\n\n\n\
Delete\nAllows deletion of a wave, template, or all \
files of both types.\n\nDelete / <Wave\\Template>\nActivates a menu of loaded wave \
files, from which a single item can be selected for deletion. Note that the \
'State / Load' button may remain inactive ('greyed out') even though no \
waves or templates remain loaded. An inactive 'State / Load' may be made \
active by 'Delete / All' even though no files are loaded.\n\nDelete / \
All\nDeletes all loaded files on activation and, if 'State / Load' is \
inactive, restores its status to active.\n\n\n\
State\nActivates a menu allowing loading and saving of state files. A state \
file contains all information about a mix, containing details of loaded \
files, templates and file selections.\n\nState / Load\nIf a state file has been \
saved, this loads it. All waves and templates loaded, together with any \
selections made when viewers were popped down with 'close', will be restored, \
preserving the last-used mix parameters. The function is made inactive so that \
a further 'State / Load' cannot be executed. The 'State / Save' function is \
rendered active.\n\nState / Save\nSaves the \
current mix parameters: loaded waves, templates and their selections. If no \
waves have been loaded (and a mix cannot occur) then an error message is \
displayed and the 'save' operation fails.\n\n\nInfo\nPops up a menu with \
wave and template buttons, which, when activated, produce menus of loaded \
waves and templates respectively.\n\nInfo / Wave\nA menu of loaded waves is \
displayed. Selection of an item from this list pops up a display box \
with information about the selected wave.\n\nInfo / Template\nThis works in \
the same way, producing popup displays of template information.\n\n\n\
Mixdown\nA file requestor is displayed. A file name can be entered in the \
'Selection' text field; overwriting of an existing file is not permitted. \
Either a new unique filename must be used or the existing file manually \
deleted.\n\n\nExit\nPops up a \
dialogue box 'Really quit Mixwave?' with 'Ok' and 'Cancel' buttons which do \
just what you expect. Note that it is not possible to close the application \
from the top-level window containing the menu buttons with the window-manager \
'close' icon at the top right of the window. File / Exit must be used.");

	_edit->setEditStatus ( False );
}


void FileHelpCmd::okCallback ( XtPointer clientData, char * text )
{
	FileHelpCmd *obj = ( FileHelpCmd * ) clientData;

	obj->ok( clientData );	// ok mapped to 'enter'
}


void FileHelpCmd::cancelCallback ( XtPointer clientData )
{
	FileHelpCmd *obj = ( FileHelpCmd * ) clientData;

	obj->ok( clientData );	// call ok to delete object
}


void FileHelpCmd::ok ( void *clientData )
{
	FileHelpCmd *obj = ( FileHelpCmd * ) clientData;

	if (obj->_editRealised == TRUE )
	{
		obj->_editRealised = FALSE;
		delete obj->_edit;
	}
}
