/*
	ModifyArrayCmd.h - shift/scale data array

	Will Eighteen, 2000, 2006: will@opaline.demon.co.uk
*/

#ifndef MODIFYARRAYCMD_H
#define MODIFYARRAYCMD_H


#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif

#include <NoUndoCmd.h>

#define LABELSIZE 64


class DMenuCmd;

class ModifyArrayCmd : public NoUndoCmd
{
	public:
		ModifyArrayCmd ( char *, int, unsigned int, unsigned int );

	protected:
		virtual void doCommand();	/* modify array */

	private:
		/* callback for WM 'X' */
		static void clientMessageProc ( Widget, XtPointer, XmAnyCallbackStruct * );

		static void waveSelCallback ( Widget, XtPointer, XtPointer );
		static void templateSelCallback ( Widget, XtPointer, XtPointer );
		static void modifyCallback ( Widget, XtPointer, XtPointer );
		static void quitCallback ( Widget, XtPointer, XtPointer );

		static void waveMenuSelectionCallback ( void *, unsigned int, char * );
		static void templateMenuSelectionCallback ( void *, unsigned int, char * );

		/* Callbacks for data change by user */
		static void field1EntryCallback ( Widget, XtPointer, XtPointer );
		static void field2EntryCallback ( Widget, XtPointer, XtPointer );

		/* fns called when data in text box is changed */
		void field1Entry ( char * );
		void field2Entry ( char * );
		void changeField1 ( float );
		void changeField2 ( float );

		int clientMessage ( XmAnyCallbackStruct * );
		int checkTextEntry ( char * );
		void waveSel();
		void templateSel();
		void modify();
		void quit();
		void waveSelected ( unsigned int );
		void templateSelected ( unsigned int );
		void stripName ( char * );
		void setTitle ( char * );

		Boolean _modifyRealised;
		Boolean _templateRealised;
		Boolean _waveRealised;
		int *_iData;
		float *_fData;
		DMenuCmd *_waveMenu;
		DMenuCmd *_templateMenu;
		const char *_name;
		char _labelString[LABELSIZE];
		long _startData, _endData;
		int _dataType;	/* 0 = int, 1 = float */
		unsigned int _numDigits;
		unsigned int _fpDigits;
		unsigned int _selectedItemNum;
		int _sourceType;	/* 0 = template, 1 = wave */
		float _shift;
		float _scale;
		unsigned _waveArrayItems;	/* num items on menu */
		unsigned _templateArrayItems;
		Widget _field1, _field2;
		Widget _label, _label1, _label2, _waveSel, _templateSel;
		Widget _popup, _form, _rc0, _rc1, _rc2, _modify, _quit;
};

#endif
