/*
 PixmapCycler.cc - modified by Will 18, 2000; will@opaline.demon.co.uk
 
 Adapted from
 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/

#include "PixmapCycler.h"


#define INVALID -1

PixmapCycler::PixmapCycler ( int numPixmaps, Dimension w, Dimension h )
{
	_numPixmaps = numPixmaps;
	_current = INVALID;
	_pixmapList = new Pixmap[_numPixmaps];
	_width = w;
	_height = h;
}


PixmapCycler::~PixmapCycler()
{
	delete[] _pixmapList;
}



Pixmap PixmapCycler::next()
{
	// first time, call createPixmaps(), implemented by derived class
	if ( _current == INVALID )
	{
		createPixmaps();
		_current = 0;
	}
	
	if ( _current >= _numPixmaps )
			_current = 0;

	return ( _pixmapList[_current++] );
}


Pixmap PixmapCycler::previous()
{
	if ( _current > 0 )
		_current--;
		
	return ( _pixmapList[_current] );
}


Pixmap PixmapCycler::currentPixmap()
{
	return ( _current );
}



Pixmap PixmapCycler::numPixmaps()
{
	return _numPixmaps;
}
